// DuraCalc.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "DuraCalc.h"

#define MAX_LOADSTRING	(100)
#define Win_W			(350)	// EChE̕
#define Win_H			(370)	// EChE̍
#define DEFAULT_TEMPO	"120"	// ftHgTempo()
#define DEFAULT_RESOLUT	"480"	// ftHg̕\()

// O[oϐ:
HINSTANCE hInst;						// ݂̃C^[tFCX
HWND hWndDlg;							// C([hX_CAO)̃nh
HHOOK hHook;							// Message擾ptbN(TABړ擾p)
TCHAR szTitle[MAX_LOADSTRING];			// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];	// C EBhE NX

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	Calc(HWND, UINT, WPARAM, LPARAM);
void ClearEditValues(void);
void CalcEditValues(double dTempo, double dResolution);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_DURACALC, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_DURACALC));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_DURACALC));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_DURACALC);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, Win_W, Win_H, NULL, NULL, hInstance, NULL);
//      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   hWndDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, Calc);
   if (!hWndDlg)
   {
      return FALSE;
   }

	SendDlgItemMessage(hWndDlg, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM)_T(DEFAULT_TEMPO)); // Tempo
	SendDlgItemMessage(hWndDlg, IDC_EDIT2, WM_SETTEXT, 0, (LPARAM)_T(DEFAULT_RESOLUT)); // \

	CalcEditValues(120, 480);

	ShowWindow(hWndDlg, nCmdShow);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWndDlg);
	UpdateWindow(hWnd);

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	RECT rectDlg;

	switch (message)
	{
	case WM_CREATE:
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_ACTIVATE: // Avؑւ̓̓tH[JXO΍
		SendMessage(hWndDlg, WM_SETFOCUS, NULL, 0); // _CAO{bNXɃtH[JXړ
		break;
	case WM_SIZE:
		GetClientRect(hWnd, &rectDlg);
		SetWindowPos(hWndDlg, HWND_TOP, 0, 0, rectDlg.right, rectDlg.bottom, SWP_SHOWWINDOW);
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (IDOK == LOWORD(wParam))
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

// Message擾ptbN([hX_CAOTabړ擾p)
LRESULT FAR PASCAL GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	LPMSG lpMsg = (LPMSG) lParam;

	if ((0 <= nCode ) && (PM_REMOVE == wParam))
	{
		// Don't translate non-input events.
		if ((WM_KEYFIRST <= lpMsg->message) && (WM_KEYLAST >= lpMsg->message))
		{
			if (IsDialogMessage(hWndDlg, lpMsg))
			{
				// The value returned from this hookproc is ignored, 
				// and it cannot be used to tell Windows the message has been handled.
				// To avoid further processing, convert the message to WM_NULL 
				// before returning.
				lpMsg->message = WM_NULL;
				lpMsg->lParam  = 0;
				lpMsg->wParam  = 0;
			}
		}
	}

   return CallNextHookEx(hHook, nCode, wParam, lParam);
}

// GateTimevZ_CAÕnhłB
INT_PTR CALLBACK Calc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult;
	TCHAR szTempo[MAX_LOADSTRING];					// Tempo
	TCHAR szResolution[MAX_LOADSTRING];				// \

	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		hHook = SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc, NULL, GetCurrentThreadId());
		return (INT_PTR)TRUE;
	case WM_COMMAND:
		if (IDB_CALC == LOWORD(wParam))
		{
			lResult = SendDlgItemMessage(hWndDlg, IDC_EDIT1, WM_GETTEXT, MAX_LOADSTRING, (LPARAM)szTempo);
			if (0 == lResult)
			{
				ClearEditValues();
				return (INT_PTR)FALSE;
			}
		    lResult = SendDlgItemMessage(hWndDlg, IDC_EDIT2, WM_GETTEXT, MAX_LOADSTRING, (LPARAM)szResolution);
			if (0 == lResult)
			{
				ClearEditValues();
				return (INT_PTR)FALSE;
			}
			if (0 == _tstof(szResolution))
			{
				ClearEditValues();
				return (INT_PTR)FALSE;
			}
			CalcEditValues(_tstof(szTempo), _tstof(szResolution));
			return (INT_PTR)TRUE;
		}
		break;
	case WM_DESTROY:
		UnhookWindowsHookEx(hHook);
		return (INT_PTR)FALSE;
	}
	return (INT_PTR)FALSE;
}

// sl͎̓̏
void ClearEditValues(void)
{
	SendDlgItemMessage(hWndDlg, IDC_EDIT3, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT4, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT5, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT6, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT7, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT8, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT9, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT10, WM_SETTEXT, 0, (LPARAM)_T("--"));

	SendDlgItemMessage(hWndDlg, IDC_EDIT11, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT12, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT13, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT14, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT15, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT16, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT17, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT18, WM_SETTEXT, 0, (LPARAM)_T("--"));

	SendDlgItemMessage(hWndDlg, IDC_EDIT19, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT20, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT21, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT22, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT23, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT24, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT25, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT26, WM_SETTEXT, 0, (LPARAM)_T("--"));

	SendDlgItemMessage(hWndDlg, IDC_EDIT27, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT28, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT29, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT30, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT31, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT32, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT33, WM_SETTEXT, 0, (LPARAM)_T("--"));
	SendDlgItemMessage(hWndDlg, IDC_EDIT34, WM_SETTEXT, 0, (LPARAM)_T("--"));
}

// GateTiměvZ̏
void CalcEditValues(double dTempo, double dResolution)
{
	double dGateTimeBase;
	double dGateTimeTick;
	TCHAR szGateTime[MAX_LOADSTRING];					// GateTime (msec)

	dGateTimeBase = dTempo * dResolution;
	dGateTimeBase = 60000 / dGateTimeBase;

	dGateTimeTick = dResolution / 8.0; // 4 / 32
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT3, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT4, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution / 4.0; // 4 / 16
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT5, WM_SETTEXT, 0, (LPARAM)szGateTime);
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT6, WM_SETTEXT, 0, (LPARAM)szGateTime);

	dGateTimeTick = dResolution / 2.0; // 4 / 8
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT7, WM_SETTEXT, 0, (LPARAM)szGateTime);
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT8, WM_SETTEXT, 0, (LPARAM)szGateTime);

	dGateTimeTick = dResolution; // 4 / 4
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT9, WM_SETTEXT, 0, (LPARAM)szGateTime);
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT10, WM_SETTEXT, 0, (LPARAM)szGateTime);

	dGateTimeTick = dResolution * 2.0; // 4 / 2
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT11, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT12, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution * 4.0; // 4 / 1
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT13, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT14, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution * 8.0; // 4 * 2
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT15, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT16, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution * 16.0; // 4 * 4
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT17, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT18, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	// t_
	dGateTimeTick = dResolution * 1.5 / 8.0; // 4 / 32 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT19, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT20, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution * 1.5 / 4.0; // 4 / 16 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT21, WM_SETTEXT, 0, (LPARAM)szGateTime);
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT22, WM_SETTEXT, 0, (LPARAM)szGateTime);

	dGateTimeTick = dResolution * 1.5 / 2.0; // 4 / 8 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT23, WM_SETTEXT, 0, (LPARAM)szGateTime);
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT24, WM_SETTEXT, 0, (LPARAM)szGateTime);

	dGateTimeTick = dResolution * 1.5; // 4 / 4 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT25, WM_SETTEXT, 0, (LPARAM)szGateTime);
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT26, WM_SETTEXT, 0, (LPARAM)szGateTime);

	dGateTimeTick = dResolution * 3.0; // 4 / 2 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT27, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT28, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution * 6.0; // 4 / 1 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT29, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT30, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution * 12.0; // 4 * 2 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT31, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT32, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec

	dGateTimeTick = dResolution * 24.0; // 4 * 4 * 1.5
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeTick);
	SendDlgItemMessage(hWndDlg, IDC_EDIT33, WM_SETTEXT, 0, (LPARAM)szGateTime); // Tick
	_stprintf_s(szGateTime, MAX_LOADSTRING, _T("%.2f"), dGateTimeBase * dGateTimeTick); // dResolution * dGateTimeTick
	SendDlgItemMessage(hWndDlg, IDC_EDIT34, WM_SETTEXT, 0, (LPARAM)szGateTime); // msec
}